# INA260 for BeagleBone Black dataset

Author: [Loïc Guégan](https://loicguegan.com)

Date: 13 September 2023

Publication: <todo>

# Dataset files
For more details, see publication above.
## pure_read.csv
### Description
They are 8 experiments in that csv:
1) inmem=0, usen=1
2) inmem=0, usen=2
3) inmem=0, usen=3
4) inmem=0, usen=4

Then, the same with inmem=1. Experiment ends when `nread` amount of samples (see columns infos) are reached with each INA260.

### Columns infos
- usen: Number of INA260 monitored in parallel
- nread: Number of power measurement to collect on an INA260 before stopping the monitoring on that chip
- inmem: Set to 1 if power measurement are stored in memory and 0 otherwise (in a file)
- timestamp: tv_sec field of the `struct timespec` obtained with the `clock_gettime(CLOCK_REALTIME, ...)` call when the power sample was collected (in seconds)
- nsecs: tv_nsec field of the `struct timespec` obtained with the `clock_gettime(CLOCK_REALTIME, ...)` call when the power sample was collected
- resident: The `%M` field obtained with /usr/bin/time in KB
- power: The power sample in Watts
- device_id: Combination of the bus and addr column
- bus: The i2c bus used by the given INA260
- addr: The i2c address the the INA260

## rpi_iperf.csv
### Columns infos
- bw: monitored (with iperf) bandwidth (in Mbps) between the BeagleBone Black and the zmq subscriber

## zmq.csv
### Description
They are 4 experiments in that csv:
1) usen=1
2) usen=2
3) usen=3
4) usen=4

### Columns infos
- duration: Experiment duration in seconds
- rest: Rest time in seconds between each experiments
- msgsize: Maximum message size in byte (if this size is exceeded, measurements are lost (did not happened during these experiments))
- logdelay: Delay in seconds between 2 consecutive measurements (if 0 measurements are done as fast as possible)

# Monitored Hardware

Address 0x40:
- Load: 1Kohm resistor
- Alim: Some random 5V alim DC

Address 0x41:
- Load: Raspberri Pi 3 model B (2016)
- Alim: 5.1V rpi alim
- Note: Powered through GPIO 2 and 6
- OS: 2023-05-03-raspios-bullseye-arm64-lite.img
- OS sha256sum (.img file): 9cd68ff450bc0fe0ac5b60e32723bc403ebca89d1214714e8e74361370d25204

Address 0x42:
- Load: Raspberri Pi 3 model B+ (2017)
- Alim: 5.1V rpi alim
- OS: see 0x41

Address 0x43:
- Load: Raspberry Pi 4 model B  (2018)
- Alim: 5.1V rpi alim
- OS: see 0x41

# Files
## sandbox/config
	# Global Configuration:
	inadev="2:0x40 2:0x41 2:0x42 2:0x43"
	bbhost=debian@192.168.6.2
	delaypurezmq=10
	delayiperfpure=10
	
	# Pure Read Experiments:
	nread=500000
	readrest=60
	
	# ZMQ Experiments:
	zmqrest=60
	zmqduration=300
	hostip=192.168.7.1
	zmqport=5556
	zmqlogdelay=0
	zmqloginterval=60
	zmqmsgsize=20242880
	zmqmaxqueue=1